#include <iostream>
#include <cmath>

using namespace std;

bool is_square(long long x)
{
    long long i = 2;
    if (x < 0) return true;
    else
    {
       while ((x > 1) & (pow(x, 0.5) >= i))
       {
           if (x % i == 0)
           {
               if (x % (i * i) != 0) return true;
               else x /= (i * i);
           }
           else i += 1;
       }
    }
    return false;
}

int main()
{
    long long k, n = 0;
    cin >> k;
    if ((k % 2 == 0) & (k % 4 != 0)) cout << "none";
    else
    {
        while (is_square(k))
        {
            k += 2*n + 1;
            n++;
        }
        cout << pow(k, 0.5);

    }
    return 0;
}

